package me.Demon.DemonLevels;

import me.Demon.DemonLevels.api.DLevelAPI;
import me.clip.placeholderapi.expansion.PlaceholderExpansion;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.text.DecimalFormat;

public class LevelExpansion extends PlaceholderExpansion {
    private Plugin plugin;

    public LevelExpansion(Plugin plugin) {
        this.plugin = plugin;
    }

    @Override
    public boolean persist() {
        return true;
    }

    @Override
    public boolean canRegister() {
        return true;
    }

    @Override
    public String getAuthor() {
        return plugin.getDescription().getAuthors().toString();
    }

    @Override
    public String getIdentifier() {
        return "dlevel";
    }

    @Override
    public String getVersion() {
        return plugin.getDescription().getVersion();
    }

    @Override
    public String onPlaceholderRequest(Player player, String indentifier) {
        if (indentifier.equalsIgnoreCase("expbl")) {
            if(Main.serverManage.getExpMultiplicity() <= 1.0){
                return "0.00";
            }
            return (Main.serverManage.getExpMultiplicity() * 100)+"";
        }else if (indentifier.equalsIgnoreCase("level")) {
            return ""+DLevelAPI.getPlayerLevel(player);
        }else if(indentifier.equalsIgnoreCase("exp")){
            return ""+DLevelAPI.getPlayerExp(player);
        }else if(indentifier.equalsIgnoreCase("exptolevel")){
            return ""+DLevelAPI.getPlayerExpToLevel(player);
        }else if(indentifier.equalsIgnoreCase("totalexp")){
            return ""+DLevelAPI.getPlayerTotalExp(player);
        }else if(indentifier.equalsIgnoreCase("upexp")){
            BigInteger exp = DLevelAPI.getPlayerExp(player);
            BigInteger upExp = DLevelAPI.getPlayerExpToLevel(player);
            // 将 BigInteger 转换为 BigDecimal 以支持浮点运算
            BigDecimal expDecimal = new BigDecimal(exp);
            BigDecimal upExpDecimal = new BigDecimal(upExp);
            // 计算经验百分比
            BigDecimal percentage = expDecimal.divide(upExpDecimal, 2, RoundingMode.HALF_UP).multiply(BigDecimal.valueOf(100));
            return String.format("%.1f", percentage);
        }else if (indentifier.equalsIgnoreCase("baifenbi")) {
            BigInteger exp = DLevelAPI.getPlayerExp(player);
            BigInteger upExp = DLevelAPI.getPlayerExpToLevel(player);
            // 将 BigInteger 转换为 BigDecimal 以支持浮点运算
            BigDecimal expDecimal = new BigDecimal(exp);
            BigDecimal upExpDecimal = new BigDecimal(upExp);
            // 计算经验百分比
            BigDecimal percentage = expDecimal.divide(upExpDecimal, 2, RoundingMode.HALF_UP).multiply(BigDecimal.valueOf(100));
            return String.format("%.3f", percentage);
        }else
        if (indentifier.equalsIgnoreCase("up")) {
            int level = DLevelAPI.getPlayerLevel(player);
            BigInteger upexp = DLevelAPI.getLevelNeedExp(level);
            BigInteger playerExp = DLevelAPI.getPlayerExp(player);
            // 计算所需的剩余经验
            BigInteger remainingExp = upexp.subtract(playerExp);
            // 将 BigInteger 转换为 int，以便进行比较和格式化
            int exp = remainingExp.intValue();
            // 格式化剩余经验，根据其大小选择合适的单位
            if (exp >= 10000000) { // 如果剩余经验大于等于 10,000,000
                // 将经验转换为百万单位，并格式化为 "x.xx m"
                exp = exp / 1000000;
                return new DecimalFormat(",###.#").format(exp) + "m";
            } else if (exp >= 1000000) { // 如果剩余经验大于等于 1,000,000
                // 将经验转换为万单位，并格式化为 "x.xx w"
                exp = exp / 10000;
                return new DecimalFormat(",###.#").format(exp) + "w";
            }
            // 如果剩余经验小于 1,000,000，直接格式化为 "x.xxx"
            return new DecimalFormat(",###.##").format(remainingExp);
        }
        return "";
    }
}
