package me.Demon.DemonLevels;

import me.Demon.DemonLevels.command.MainCmd;
import me.Demon.DemonLevels.listener.MobDeath;
import me.Demon.DemonLevels.listener.JoinEvent;
import me.Demon.DemonLevels.listener.UpgradePrompt;
import me.Demon.DemonLevels.manage.ServerManage;
import me.Demon.DemonLevels.util.ConfigYml;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static boolean Debug = true;

    public static String TypeEvent = "DragonCore";

    public static ServerManage serverManage;
    public static ConfigYml configYml;

    @Override
    public void onEnable() {
        plugin = this;
        DemonAPI.sendConsoleMessage("§f[§6!§f] §aDemonLevels ("+plugin.getServer().getVersion()+") §f开始加载");
        loadConfigData();
        serverManage = new ServerManage(getConfig());
        getCommand("dlevel").setExecutor(new MainCmd());
        getServer().getPluginManager().registerEvents(new MobDeath(),this);
        getServer().getPluginManager().registerEvents(new JoinEvent(),this);
        getServer().getPluginManager().registerEvents(new UpgradePrompt(),this);
        if (Bukkit.getPluginManager().getPlugin("PlaceholderAPI") != null) {
            new LevelExpansion(this).register();
            DemonAPI.sendConsoleMessage("§f[§a!§f] §fPlaceholderAPI §8> §6完成");
        }
        DemonAPI.sendConsoleMessage("§f[§6!§f] §aDemonLevels §f加载完成,祝你使用愉快！");
        DemonAPI.sendConsoleMessage("§f[§6!§f] §b极光像素工作室出品");
    }


    @Override
    public void onDisable() {
        for (String uuid : serverManage.getDataHashMap().keySet()){
            serverManage.getDataHashMap().get(uuid).savePlayerData();
        }
        serverManage.getDataHashMap().clear();
        DemonAPI.sendConsoleMessage("§f[§c!§f] §aDemonLevels §f卸载完成,欢迎下次使用！");
    }

    public void loadConfigData(){
        File file = new File(getDataFolder(),"Data.yml");
        FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
        configYml = new ConfigYml(file,yml);
    }

    public void reloadLoadData(){
        loadConfigData();
        plugin.reloadConfig();
        serverManage = new ServerManage(getConfig());
        for (Player onlineP : Bukkit.getOnlinePlayers()){
            String uuid = onlineP.getUniqueId().toString();
            Main.serverManage.getPlayerData(uuid);
        }
    }
}
