package me.Demon.DemonLevels.command;

import com.yaohun.playermanage.PlayerManage;
import me.Demon.DemonLevels.Main;
import me.Demon.DemonLevels.api.DLevelAPI;
import me.Demon.DemonLevels.data.PlayerData;
import me.Demon.DemonLevels.manage.ServerManage;
import me.Demon.DemonLevels.util.GameUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.command.*;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;

import java.math.BigInteger;
import java.time.*;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class MainCmd implements CommandExecutor , TabCompleter {
    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (!sender.isOp()) {
            return true;
        }
        if(args.length == 0){
            sender.sendMessage("§r");
            sender.sendMessage("§e------- ======= §6斗魂学院等级系统 §e======= -------");
            sender.sendMessage("§2/dlevel dexp §e[倍率] §f- §2设置经验倍率");
            sender.sendMessage("§2/dlevel dexp §e[倍率] §2<HourS> §f- §2设置经验倍率");
            sender.sendMessage("§2/dlevel look §e[玩家名] §f- §2查看等级信息");
            sender.sendMessage("§2/dlevel give §e[玩家名] §2<数值> §f- §2给予游戏经验");
            sender.sendMessage("§2/dlevel take §e[玩家名] §2<数值> §f- §2扣除游戏经验");
            sender.sendMessage("§2/dlevel setlevel §e[玩家名] §2<数值> §f- §2设置游戏等级");
            sender.sendMessage("§2/dlevel settotal §e[玩家名] §2<数值> §f- §2设置游戏总经验");
            sender.sendMessage("§2/dlevel kmob §e[怪物代号] §2<min> <max> §f- §2设置怪物经验");
            sender.sendMessage("§e------- ======= §6斗魂学院等级系统 §e======= -------");
            sender.sendMessage("§r");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("reload")){
            Main.plugin.reloadLoadData();
            DemonAPI.sendMessage(sender,"配置文件均已重新载入.");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("save")){
            ServerManage serverManage = Main.serverManage;
            for (String uuid : serverManage.getDataHashMap().keySet()){
                serverManage.getDataHashMap().get(uuid).savePlayerData();
            }
            DemonAPI.sendMessage(sender,"玩家数据已保存.");
            return true;
        }
        if(args[0].equalsIgnoreCase("dexp")){
            if(args.length >= 2){
                double doubleExp = GameUtil.convertDouble(args[1]);
                long defaultTime = 7 * 24 * 60 * 60 * 1000L; // 默认开启经验倍率时间7天
                if(args.length >= 3){
                    defaultTime = GameUtil.convertInt(args[2]) * 60 * 60 * 1000L;
                }
                long expMultipleTime = System.currentTimeMillis() + defaultTime; // 本次经验倍率持续时间
                if(doubleExp >= 1.1) {
                    Main.serverManage.setExpMultiplicity(doubleExp,expMultipleTime);
                    for (Player p : Bukkit.getOnlinePlayers()) {
                        DemonAPI.sendMessage(p, "当前经验获取倍率为: §e§l"+doubleExp*100+"%");
                        p.sendTitle("§d§l"+doubleExp*100+"%","§f持续时间: §a"+GameUtil.formatTime(defaultTime));
                        p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 1, 1);
                    }
                }
            }
            return true;
        }
        if(args[0].equalsIgnoreCase("kmob")){
            if(args.length >= 3){
                String mobKey = args[1];
                int min = GameUtil.convertInt(args[2]);
                int max = min;
                if(args.length == 4){
                    max = GameUtil.convertInt(args[3]);
                    Main.configYml.setKillsExp(mobKey,min,max);
                    DemonAPI.sendMessage(sender,"成功设置 §6"+mobKey+" §a经验掉落为: §d"+min+"§a~§d"+max);
                }else{
                    Main.configYml.setKillsExp(mobKey,max);
                    DemonAPI.sendMessage(sender,"成功设置 §6"+mobKey+" §a经验掉落为: §d"+max);
                }
            }
            return true;
        }
        if(args.length == 3){
            String name = args[1];
            String uuid = PlayerManage.getNameToUuid(name);
            if(uuid.equalsIgnoreCase("无数据")){
                DemonAPI.sendMessage(sender,"未查询到该玩家的UUID.");
                return true;
            }
            Player player = Bukkit.getPlayer(name);
            int value = GameUtil.convertInt(args[2]);
            if(player == null) {
                DemonAPI.sendMessage(sender,"目标玩家不在线.");
                return true;
            }
            if(args[0].equalsIgnoreCase("give")){
                DLevelAPI.addExp(player,value);
                DemonAPI.sendMessage(sender,"给予 §6"+name+" §a经验: §d+"+value);
            }else if(args[0].equalsIgnoreCase("take")){
                DLevelAPI.takeExp(player,value);
                DemonAPI.sendMessage(sender,"扣除 §6"+name+" §a经验: §d-"+value);
            }else if(args[0].equalsIgnoreCase("setlevel")){
                DLevelAPI.setPlayerLevel(player,value);
                DemonAPI.sendMessage(sender,"设置 §6"+name+" §a等级: §dLv."+value);
            }else if(args[0].equalsIgnoreCase("settotal")){
                BigInteger bigInteger = new BigInteger(args[2]);
                DLevelAPI.setTotalExp(player,bigInteger);
                DemonAPI.sendMessage(sender,"设置 §6"+name+" §a总经验: §d"+bigInteger.toString());
            }
            return true;
        }
        if(args.length == 2 && args[0].equalsIgnoreCase("look")){
            String playerName = args[1];
            String uuid = PlayerManage.getNameToUuid(playerName);
            if(uuid.equalsIgnoreCase("无数据")){
                DemonAPI.sendMessage(sender,"未查询到该玩家的UUID.");
                return true;
            }
            Player player = Bukkit.getPlayer(playerName);
            if(player == null) {
                PlayerData data = new PlayerData(uuid);
                DemonAPI.sendMessage(sender,"玩家 §e"+playerName+" §a的等级信息:");
                int playerLevel = data.getLevel();
                sender.sendMessage("§f- §a等级: §dLv."+playerLevel);
                sender.sendMessage("§f- §a经验: §d"+data.getExp().toString()+"§a/§d"+ DLevelAPI.getLevelNeedExp(playerLevel));
                sender.sendMessage("§f- §a等级: §d"+data.getTotalExp().toString());
            }else{
                PlayerData data = Main.serverManage.getPlayerData(uuid);
                DemonAPI.sendMessage(sender,"玩家 §e"+playerName+" §a的等级信息:");
                int playerLevel = data.getLevel();
                sender.sendMessage("§f- §a等级: §dLv."+playerLevel);
                sender.sendMessage("§f- §a经验: §d"+data.getExp().toString()+"§a/§d"+ DLevelAPI.getLevelNeedExp(playerLevel));
                sender.sendMessage("§f- §a等级: §d"+data.getTotalExp().toString());
            }
            return true;
        }
        return false;
    }

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) {
        List<String> completions = new ArrayList<>();
        if(args.length == 1){
            completions.add("dexp");
            completions.add("look");
            completions.add("give");
            completions.add("take");
            completions.add("setlevel");
            completions.add("settotal");
            completions.add("kmob");
        }else if(args.length == 2){
            String[] onlinePlayers = Bukkit.getOnlinePlayers().stream().map(HumanEntity::getName).toArray(String[]::new);
            completions.addAll(Arrays.asList(onlinePlayers));
        }else if(args.length == 3){
            completions.add("单位小时");
            completions.add("经验");
            completions.add("最小经验");
        }else if(args.length == 4){
            completions.add("最小经验");
            completions.add("最大经验");
        }
        return completions;
    }
}
