package me.Demon.DemonLevels.listener;

import io.lumine.xikage.mythicmobs.api.bukkit.events.MythicMobDeathEvent;
import me.Demon.DemonLevels.Main;
import me.Demon.DemonLevels.api.DLevelAPI;
import me.Demon.DemonLevels.data.PlayerData;
import me.Demon.DemonLevels.event.ShareExpEvent;
import me.Demon.DemonLevels.manage.MobsManage;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonTeam.DTeamAPI;
import me.Demon.DemonTeam.TeamData;
import me.Demon.DemonVipSystem.DvipAPI;
import net.md_5.bungee.api.ChatMessageType;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.serverct.ersha.jd.AttributeAPI;
import org.serverct.ersha.jd.Ha;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MobDeath implements Listener {

    @EventHandler
    public void onkillDropExp(MythicMobDeathEvent e) {
        LivingEntity killer = e.getKiller(); // 获取击杀mm怪的生物
        if (!(killer instanceof Player)) {return;}// 判断生物是否是玩家
        String mmKey = e.getMob().getType().getInternalName(); // 获取MM怪物的id
        if (Main.configYml.getMobsManage(mmKey) == null){return;}
        MobsManage mobsManage = Main.configYml.getMobsManage(mmKey);
        // 获取服务器当前经验倍率
        double serverDouble = Main.serverManage.getExpMultiplicity();
        // 检测服务器经验倍率时间是否关闭
        if(serverDouble >= 1.1 && Main.serverManage.isExpMultipleTime()){
            Main.serverManage.setExpMultiplicity(1.0,System.currentTimeMillis());
            System.out.println("[调试 - 等级] 经验倍率已恢复默认1.0");
            serverDouble = 1.0;
            for (Player p :Bukkit.getOnlinePlayers()) {
                DemonAPI.sendMessage(p,"经验倍率加成已结束！已经恢复默认倍率。");
                p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
            }
        }
        // 获取玩家经验加成属性
        double att_expAddition = 1;
        Player p = ((Player) killer).getPlayer();
        String playerName = p.getName(); // 获取玩家名字
        if(AttributeAPI.getAttrData(p) != null) {
            if (AttributeAPI.getAttrData(p).getAttributeValue().get("经验加成") != null) {
                att_expAddition = 1 + (AttributeAPI.getAttrData(p).getAttributeValue().get("经验加成") / 100);
            }
        }
        // 获取死亡后的经验 x 全服经验倍率 x 玩家经验加成
        // 假设 死亡经验 = 10  server = 2.0  att = 1.5
        // 则结果将会是 10 * 2.0 * 1.5 = 30
        int exp = (int) (mobsManage.getExp() * serverDouble * att_expAddition);
        // 假设serverDouble = 2.0  att_expAddition = 1.50;
        // 则结果将会是 2.0 + 1.5 = 3.5   但实际上是 1.0 + 0.5 = 1.5
        double magnificationDisplay = (serverDouble + (att_expAddition - 1)); // 获取玩家当前倍率
        // 判断玩家是否在队伍之中
        boolean isTeamExit = false;
        Map<TeamData, Double> teamMap = new HashMap<>();
        if(DTeamAPI.isPlayerExistTeam(playerName)){
            TeamData teamData = DTeamAPI.getPlayerTeam(playerName); // 获取队伍数据
            // 判断队伍是否开启经验共享 并成员大于2人
            if(teamData.getMemberList().size() >= 2 && teamData.isExpButt()){
                teamMap.put(teamData, (double) exp);
                isTeamExit = true;
            }
        }
        if(!isTeamExit){
            int magnificationDisplayString = (int) (magnificationDisplay * 100);
            // 给予玩家经验值
            DLevelAPI.addExp(p,exp);
            experienceGainTips(p,exp,magnificationDisplayString);
            if(magnificationDisplayString >= 1) {
                p.sendMessage("§f[§e提示§f] §7你的经验增加了§6" + exp + "§7! [§a+" + magnificationDisplayString + "%§7]");
            }else{
                p.sendMessage("§f[§e提示§f] §7你的经验增加了§6" + exp + "§7!");
            }
        } else {
            for (TeamData teamData : teamMap.keySet()){
                Player owner = teamData.getOwner_Player();
                if (owner == null) {
                    return;
                }
                // 获取队伍成员列表
                List<String> memberList = teamData.getMemberList();
                double teamExp = teamMap.get(teamData); // 获取队伍瓜分经验数量
                if(memberList.size() >= 2) { // 当成员满足3人后 开启队伍经验加成
                    double teamAddonExp = 1.0;
                    if (Main.serverManage.isLinkDemonVipSystem()) {
                        int vip_level = DvipAPI.getLevel(owner.getName());
                        if (vip_level >= 8) {
                            teamAddonExp = 1.30;
                        } else if (vip_level >= 7) {
                            teamAddonExp = 1.20;
                        } else if (vip_level >= 6) {
                            teamAddonExp = 1.15;
                        } else if (vip_level >= 5) {
                            teamAddonExp = 1.10;
                        } else if (vip_level >= 4) {
                            teamAddonExp = 1.05;
                        }
                        magnificationDisplay = magnificationDisplay + (teamAddonExp - 1);
                    }
                    teamExp = teamExp * teamAddonExp;
                }
                List<String> playerList = new ArrayList<>(); // 参与经验共享的成员
                for (String memberName : memberList){// 遍历成员列表
                    Player teamPlayer = Bukkit.getPlayer(memberName);
                    if(teamPlayer == null || !teamPlayer.isOnline()){
                        continue;
                    }
                    // 获取队友所在世界名
                    String locationWorld = teamPlayer.getWorld().getName();
                    if(supportedDirectness(locationWorld)){ // 判断玩家所处世界是否是新手世界
                        playerList.add(memberName);
                    }else if(p.getWorld().equals(teamPlayer.getWorld())){
                        // 若玩家所处世界相同则开启共享
                        // 但前提是他们两点距离不超过15格
                        double distance = p.getLocation().distance(teamPlayer.getLocation());
                        if(distance <= 50){
                            playerList.add(memberName);
                        }
                    }
                }
                int magnificationDisplayString = (int) (magnificationDisplay * 100);
                for (String memberName : memberList){
                    Player player = Bukkit.getPlayer(memberName);
                    if(player == null){continue;}
                    if(!playerList.contains(memberName)){
                        player.sendMessage("§f[§e提示§f] §7由于距离过远,组队经验共享失败.");
                        continue;
                    }
                    // 检测玩家在队伍里但是不在共享名单里
                    int shareExperience = (int) (teamExp / playerList.size());
                    // 给予玩家经验值
                    DLevelAPI.addExp(p,shareExperience);
                    experienceGainTips(player,shareExperience,magnificationDisplayString);
                    if(magnificationDisplayString >= 1){
                        player.sendMessage("§f[§e提示§f] §7队伍经验分享你获得了§6" + shareExperience + "§7! [§a+" + magnificationDisplayString + "%§7]");
                    } else {
                        player.sendMessage("§f[§c消息§f] §7队伍经验分享你获得了 §d§l+" + shareExperience);
                    }
                    ShareExpEvent share_event = new ShareExpEvent(player, shareExperience, playerList);
                    Bukkit.getPluginManager().callEvent(share_event);
                }
            }
        }
    }

    public static void experienceGainTips(Player p,int exp,int magnificationDisplayString){
        String playName = "§8§l[ §b"+p.getName()+" §8§l]";
        PlayerData playerData = Main.serverManage.getPlayerData(p.getUniqueId().toString());
        String nowexp = "§8§l[ §e§lLv."+playerData.getLevel()+"  §c§l"+playerData.getExp().toString()+"§f§l/§a§l"+DLevelAPI.getLevelNeedExp(playerData.getLevel()).toString()+" §8§l]";
        String addExp = "§8§l[ §d§l+" + exp + " §8§l]";
        if(magnificationDisplayString >= 1){
            addExp = "§8§l[ §d§l++" + exp + "++ §8§l]";
        }
        String message = playName+"      "+nowexp+"      "+addExp;
        p.spigot().sendMessage(ChatMessageType.ACTION_BAR,new TextComponent(message));
        p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP,1,1);
    }

    public static boolean supportedDirectness(String worldName){
        if(worldName.equalsIgnoreCase("lrzs")){
            return true;
        }else if(worldName.equalsIgnoreCase("xdsl")){
            return true;
        }
        return false;
    }
}
